<?php

declare(strict_types=1);

namespace mirzaev\calculator;

use mirzaev\minimal\core;
use mirzaev\minimal\router;

define('VIEWS', realpath('..' . DIRECTORY_SEPARATOR . 'views'));

// Автозагрузка
require __DIR__ . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'vendor' . DIRECTORY_SEPARATOR . 'autoload.php';

// Инициализация маршрутазитора
$router = new router;

// Запись маршрутов
$router->write('/', 'main', 'index');
$router->write('/calculator', 'calculator', 'index');
$router->write('/calculator/generate/buyer', 'calculator', 'buyer');
$router->write('/calculator/generate/complexity', 'calculator', 'complexity');
$router->write('/calculator/generate/menu', 'calculator', 'menu');
$router->write('/calculator/generate/result', 'calculator', 'result');
$router->write('/calculator/generate/divider', 'calculator', 'divider');
$router->write('/calculator/generate/laser', 'calculator', 'laser');

// Инициализация ядра
$core = new Core(namespace: __NAMESPACE__, router: $router);

// Обработка запроса
echo $core->start();
