'use strict';

let calculator = {
    index: document.getElementById("calculator"),
    calculators: [],
    settings: {
        defaults: {
            buyer: 'individual',
            complexity: 'hard',
        }
    },
    init() {
        // Инициализация калькулятора

        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ИЗБАВИТЬСЯ ОТ ТАЙМАУТОВ

        this.generate.buyer(this.settings.defaults.buyer);
        setTimeout(() => {
            this.generate.complexity(this.settings.defaults.complexity);
            setTimeout(() => {
                this.generate.menu();
                setTimeout(() => {
                    // this.calculate();
                    this.generate.result();
                }, 100);
            }, 100);
        }, 100);

        console.log('[КАЛЬКУЛЯТОР] Инициализирован');
    },
    calculate(repeated = false) {
        let result = document.getElementById("result");

        if (result === null) {
            // Не найден элемент с данными рассчета

            // Инициализия
            this.generate.result();

            if (repeated === false) {
                // Это первое выполнение функции в потенциальном цикле

                // Повтор операции
                this.calculate(true);
            }
        }
    },
    generate: {
        buyer(value = 'individual') {
            // Запрос и генерация HTML с данными о типе покупателя (юр. лицо и физ. лицо)

            const request = new XMLHttpRequest();

            request.open('GET', '/calculator/generate/buyer?value=' + value);

            request.setRequestHeader('Content-Type', 'application/x-www-form-url');

            request.addEventListener("readystatechange", () => {
                if (request.readyState === 4 && request.status === 200) {
                    calculator.index.insertAdjacentHTML('beforeend', request.responseText);

                    console.log('[КАЛЬКУЛЯТОР] Загружен элемент с кнопками выбора типа покупателя');
                }
            });

            request.send();
        },
        complexity(value = 'medium') {
            // Запрос и генерация HTML с данными о сложности работы

            const request = new XMLHttpRequest();

            request.open('GET', '/calculator/generate/complexity?value=' + value);

            request.setRequestHeader('Content-Type', 'application/x-www-form-url');

            request.addEventListener("readystatechange", () => {
                if (request.readyState === 4 && request.status === 200) {
                    calculator.index.insertAdjacentHTML('beforeend', request.responseText);

                    console.log('[КАЛЬКУЛЯТОР] Загружен элемент с кнопками выбора сложности');
                }
            });

            request.send();
        },
        menu() {
            // Запрос и генерация HTML с кнопками добавления калькулятора

            const request = new XMLHttpRequest();

            request.open('GET', '/calculator/generate/menu');

            request.setRequestHeader('Content-Type', 'application/x-www-form-url');

            request.addEventListener("readystatechange", () => {
                if (request.readyState === 4 && request.status === 200) {
                    calculator.index.insertAdjacentHTML('beforeend', request.responseText);

                    console.log('[КАЛЬКУЛЯТОР] Загружен элемент с кнопками добавления калькулятора');
                }
            });

            request.send();
        },
        result() {
            // Запрос и генерация HTML с данными о результате калькуляции

            const request = new XMLHttpRequest();

            request.open('GET', '/calculator/generate/result');

            request.setRequestHeader('Content-Type', 'application/x-www-form-url');

            request.addEventListener("readystatechange", () => {
                if (request.readyState === 4 && request.status === 200) {
                    calculator.index.insertAdjacentHTML('beforeend', request.responseText);

                    console.log('[КАЛЬКУЛЯТОР] Загружен элемент с данными о результате калькуляции');
                }
            });

            request.send();
        },
        divider(element, position) {
            // Запрос и генерация HTML с данными о результате калькуляции

            const request = new XMLHttpRequest();

            request.open('GET', '/calculator/generate/divider');

            request.setRequestHeader('Content-Type', 'application/x-www-form-url');

            request.addEventListener("readystatechange", () => {
                if (request.readyState === 4 && request.status === 200) {

                    if (element === undefined || position === undefined) {
                        // Не задан элемент и позиция добавляемого разделителя

                        // Запись разделителя в конце калькулятора
                        calculator.index.insertAdjacentHTML('beforeend', request.responseText);
                    } else {
                        // Задан элемент и позиция добавляемого разделителя

                        // Запись разделителя по заданным параметрам
                        element.insertAdjacentHTML(position, request.responseText);
                    }

                    console.log('[КАЛЬКУЛЯТОР] Загружен разделитель');
                }
            });

            request.send();
        },
        calculators: {
            laser() {
                // Запрос и генерация HTML с калькулятором лазерной резки

                // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ИЗБАВИТЬСЯ ОТ ТАЙМАУТОВ

                const request = new XMLHttpRequest();

                request.open('GET', '/calculator/generate/laser');

                request.setRequestHeader('Content-Type', 'application/x-www-form-url');

                request.addEventListener("readystatechange", () => {
                    if (request.readyState === 4 && request.status === 200) {
                        // Поиск последнего калькулятора
                        let last = calculator.calculators[calculator.calculators.length - 1];

                        if (last !== undefined && last !== null) {
                            // Найден калькулятор

                            // Запись калькулятора после последнего калькулятора
                            last.insertAdjacentHTML('afterend', request.responseText);

                            setTimeout(() => {
                                // Инициализация разделителя перед меню
                                calculator.generate.divider(last, 'afterend');
                            }, 100);
                        } else {
                            // Не найден калькулятор

                            // Поиск меню
                            let menu = document.getElementById("menu");

                            if (menu !== null) {
                                // Найдено меню

                                // Инициализация разделителя перед меню
                                calculator.generate.divider(menu, 'beforebegin');

                                setTimeout(() => {
                                    // Запись калькулятора перед меню
                                    menu.insertAdjacentHTML('beforebegin', request.responseText);
                                }, 100);
                            } else {
                                // Не найдено меню

                                // Поиск результатов калькуляции
                                let result = document.getElementById("result");

                                if (result !== null) {
                                    // Найден элемент с результатами калькуляции

                                    // Инициализация разделителя перед меню
                                    calculator.generate.divider(result, 'beforebegin');

                                    setTimeout(() => {
                                        // Запись калькулятора перед элементом с результатами калькуляции
                                        result.insertAdjacentHTML('beforebegin', request.responseText);
                                    }, 100);
                                } else {
                                    // Не найден элемент с результатами калькуляции

                                    // Инициализация разделителя перед меню
                                    calculator.generate.divider();

                                    setTimeout(() => {
                                        // Запись калькулятора в конце калькулятора
                                        calculator.index.insertAdjacentHTML('beforeend', request.responseText);
                                    }, 100);
                                }
                            }
                        }

                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ИЗБАВИТЬСЯ ОТ ТАЙМАУТОВ

                        setTimeout(() => {
                            // Поиск только что созданного калькулятора
                            let laser = document.getElementById('laser');

                            if (laser !== null) {
                                // Найден только что инициализированный (подразумевается) калькулятор лазерной резки

                                // Реинициализация идентификатора
                                laser.id = 'laser_' + calculator.calculators.length;

                                // Запись калькулятора в реестр
                                calculator.calculators.push(laser);

                                console.log('[КАЛЬКУЛЯТОР] Загружен калькулятор лазерной резки');
                            } else {
                                // Не найден только что инициализированный (подразумевается) калькулятор лазерной резки

                                console.log('[КАЛЬКУЛЯТОР] Не удалось инициализировать калькулятор лазерной резки');
                            }
                        }, 100);
                    }
                });

                request.send();
            }
        }
    }
};
